//! @file usb_standard_request.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBu(ڑF)vͯ ̧
//!
//! ̧ق͕W(ڑF)(USBdl9͎Q)ɑΉUSB߲0
//! ٰ݂܂݂܂B
//! ̧ق͔WvǗɑ΂usb_specific_request.çقٰ݂Ăяo
//! ܂B
//! (ڑF)Ұ(Lqq\)usb_descriptors.çٓɊ܂܂܂B
//!
//! @version 1.1 at90usb128-demo-hidgen-1_0_0 $Id: usb_standard_request.h,v 1.1 2006/03/13 10:09:12 rletendu Exp $
//!
//! @todo
//! @bug

#ifndef _USB_ENUM_H_
#define _USB_ENUM_H_

//_____ ݸٰ _______________________________________________________________

#include "usb_descriptors.h"

//_____ ϸ ___________________________________________________________________

//_____ W` ______________________________________________________________

//! @defgroup std_request USBuWv
//! @{

	//! @defgroup std_req_values Wv`
	//! @{
#define GET_STATUS								0x00
#define GET_DEVICE								0x01
#define CLEAR_FEATURE							0x01	//!< ̕W@\B
#define GET_STRING								0x03
#define SET_FEATURE								0x03	//!< ̕W@\B
#define SET_ADDRESS								0x05
#define GET_DESCRIPTOR							0x06
#define SET_DESCRIPTOR							0x07
#define GET_CONFIGURATION						0x08
#define SET_CONFIGURATION						0x09
#define GET_INTERFACE							0x0A
#define SET_INTERFACE							0x0B
#define SYNCH_FRAME								0x0C

#define GET_DEVICE_DESCRIPTOR					1
#define GET_CONFIGURATION_DESCRIPTOR			4

#define REQUEST_DEVICE_STATUS					0x80
#define REQUEST_INTERFACE_STATUS				0x81
#define REQUEST_ENDPOINT_STATUS					0x82
#define ZERO_TYPE								0x00
#define INTERFACE_TYPE							0x01
#define ENDPOINT_TYPE							0x02

	// Lqq`
#define DEVICE_DESCRIPTOR						0x01
#define CONFIGURATION_DESCRIPTOR				0x02
#define STRING_DESCRIPTOR						0x03
#define INTERFACE_DESCRIPTOR					0x04
#define ENDPOINT_DESCRIPTOR						0x05
#define DEVICE_QUALIFIER_DESCRIPTOR				0x06
#define OTHER_SPEED_CONFIGURATION_DESCRIPTOR	0x07

	// W@\
#define FEATURE_DEVICE_REMOTE_WAKEUP			0x01
#define FEATURE_ENDPOINT_HALT					0x00

#define TEST_J									0x01
#define TEST_K									0x02
#define TEST_SEO_NAK							0x03
#define TEST_PACKET								0x04
#define TEST_FORCE_ENABLE						0x05

	// u
#define BUS_POWERED								0
#define SELF_POWERED							1

	//! @}

	// u
#define ATTACHED						0
#define POWERED							1
#define DEFAULT							2
#define ADDRESSED						3
#define CONFIGURED						4
#define SUSPENDED						5

#define USB_CONFIG_ATTRIBUTES_RESERVED	0x80
#define USB_CONFIG_BUSPOWERED			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x00)
#define USB_CONFIG_SELFPOWERED			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x40)
#define USB_CONFIG_REMOTEWAKEUP			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x20)

//_____ 錾 __________________________________________________________________

	//! @brief uνĂƐڑĐ(ڑF)ꂽɐ^Ԃ܂B
	//! uʉp͉ꂩ̐\vsOɎׂłB
#define Is_device_enumerated()			((usb_configuration_nb!=0) ? TRUE : FALSE)
#define Is_device_not_enumerated()		((usb_configuration_nb!=0) ? FALSE : TRUE)


void usb_var_init (void);

//! @brief ̊֐͊萧߲ĂɑꂽSETUPvǂœK؂Ȋ֐
//! т܂Busb_read_request֐̔oAu͎̗v̊Ǘ
//! ܂B
//!
//! Mvx܂USBWvłȂꍇA֐usb_specific_request
//! ̓Ǝ֐Ăяo܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//! @note	xv̈ꗗ
//! GET_DESCRIPTOR
//! GET_CONFIGURATION
//! SET_ADDRESS
//! SET_CONFIGURATION
//! CLEAR_FEATURE
//! SET_FEATURE
//! GET_STATUS
//!
void usb_process_request (void);

extern U8 usb_configuration_nb;

//! @}

#endif // _USB_ENUM_H_
