/****** ͋@Bꂽ̧قłB- ҏWȂłB************* */
/****** Created: 2005-11-29 12:56 ******* Source: AT90USB1287.xml ********* */
/**************************************************************************
 *
 * - ̧ٖ		: "ioAT90USB1287.h"
 * - \		: AT90USB1287pڼ޽/ޯĂ̒`
 * - t		: 2005N1129
 * - Ŕԍ		: 2.20
 * - xEҰ	: avr@atmel.com
 * - ΏMCU	: AT90USB1287
 *
 * - ߲		: GNU AVRGCC
 *
 **************************************************************************
 */

#ifndef _IOAT90USB1287_H_
#define _IOAT90USB1287_H_

/* ***** ޲w ******************************************************* */
#define PART_NAME		AT90USB1287
#define SIGNATURE_000	0x1e
#define SIGNATURE_001	0x97
#define SIGNATURE_002	0x82

/* ***** I/Oڼ޽` ***************************************************** */
/* :
 * Definitions marked "MEMORY MAPPED"ƋLꂽ`͊gꂽI/O߰ĂIN/OUT
 * ߂Ŏgp邱Ƃł܂B
 */
#define PLLCSR			_SFR_IO8(0x29)
#define TESTPADSTATUS	_SFR_MEM8(0xfd)
#define TESTPADPULL		_SFR_MEM8(0xfe)
#define TESTPADCTRL		_SFR_MEM8(0xff)
#define UPERRX			_SFR_MEM8(0xf5)
#define UEINT			_SFR_MEM8(0xf4)
#define UPINT			_SFR_MEM8(0xf8)
#define UEBCHX			_SFR_MEM8(0xf3)
#define UPBCHX			_SFR_MEM8(0xf7)
#define UEBCLX			_SFR_MEM8(0xf2)
#define UPBCLX			_SFR_MEM8(0xf6)
#define UEDATX			_SFR_MEM8(0xf1)
#define UPDATX			_SFR_MEM8(0xaf)
#define UEIENX			_SFR_MEM8(0xf0)
#define UPIENX			_SFR_MEM8(0xae)
#define UESTA1X			_SFR_MEM8(0xef)
#define UPCFG2X			_SFR_MEM8(0xad)
#define UESTA0X			_SFR_MEM8(0xee)
#define UPSTAX			_SFR_MEM8(0xac)
#define UECFG1X			_SFR_MEM8(0xed)
#define UPCFG1X			_SFR_MEM8(0xab)
#define UECFG0X			_SFR_MEM8(0xec)
#define UPCFG0X			_SFR_MEM8(0xaa)
#define UECONX			_SFR_MEM8(0xeb)
#define UPCONX			_SFR_MEM8(0xa9)
#define UERST			_SFR_MEM8(0xea)
#define UPRST			_SFR_MEM8(0xa8)
#define UENUM			_SFR_MEM8(0xe9)
#define UPNUM			_SFR_MEM8(0xa7)
#define UEINTX			_SFR_MEM8(0xe8)
#define UPINTX			_SFR_MEM8(0xa6)
#define UDTST			_SFR_MEM8(0xe7)
#define UPINRQX			_SFR_MEM8(0xa5)
#define UDMFN			_SFR_MEM8(0xe6)
#define UHFLEN			_SFR_MEM8(0xa4)
#define UDFNUMH			_SFR_MEM8(0xe5)
#define UHFNUMH			_SFR_MEM8(0xa3)
#define UDFNUML			_SFR_MEM8(0xe4)
#define UHFNUML			_SFR_MEM8(0xa2)
#define UDADDR			_SFR_MEM8(0xe3)
#define UHADDR			_SFR_MEM8(0xa1)
#define UDIEN			_SFR_MEM8(0xe2)
#define UHIEN			_SFR_MEM8(0xa0)
#define UDINT			_SFR_MEM8(0xe1)
#define UHINT			_SFR_MEM8(0x9f)
#define UDCON			_SFR_MEM8(0xe0)
#define UHCON			_SFR_MEM8(0x9e)
#define OTGINT			_SFR_MEM8(0xdf)
#define OTGIEN			_SFR_MEM8(0xde)
#define OTGCON			_SFR_MEM8(0xdd)
#define OTGTCON			_SFR_MEM8(0xf9)
#define UDPADDH			_SFR_MEM8(0xdc)
#define UDPADDL			_SFR_MEM8(0xdb)
#define USBINT			_SFR_MEM8(0xda)
#define USBSTA			_SFR_MEM8(0xd9)
#define USBCON			_SFR_MEM8(0xd8)
#define UHWCON			_SFR_MEM8(0xd7)
#define UCSR2B			_SFR_MEM8(0xd1)
#define UCSR2A			_SFR_MEM8(0xd0)
#define UDR1			_SFR_MEM8(0xce)
#define UBRR1			_SFR_MEM16(0xcc)
#define UCSR1C			_SFR_MEM8(0xca)
#define UCSR1B			_SFR_MEM8(0xc9)
#define UCSR1A			_SFR_MEM8(0xc8)
#define TWAMR			_SFR_MEM8(0xbd)
#define TWCR			_SFR_MEM8(0xbc)
#define TWDR			_SFR_MEM8(0xbb)
#define TWAR			_SFR_MEM8(0xba)
#define TWSR			_SFR_MEM8(0xb9)
#define TWBR			_SFR_MEM8(0xb8)
#define ASSR			_SFR_MEM8(0xb6)
#define OCR2B			_SFR_MEM8(0xb4)
#define OCR2A			_SFR_MEM8(0xb3)
#define TCNT2			_SFR_MEM8(0xb2)
#define TCCR2B			_SFR_MEM8(0xb1)
#define TCCR2A			_SFR_MEM8(0xb0)
#define OCR4CH			_SFR_MEM8(0xad)
#define OCR4CL			_SFR_MEM8(0xac)
#define OCR4BH			_SFR_MEM8(0xab)
#define OCR4BL			_SFR_MEM8(0xaa)
#define OCR4AH			_SFR_MEM8(0xa9)
#define OCR4AL			_SFR_MEM8(0xa8)
#define ICR4H			_SFR_MEM8(0xa7)
#define ICR4L			_SFR_MEM8(0xa6)
#define TCNT4H			_SFR_MEM8(0xa5)
#define TCNT4L			_SFR_MEM8(0xa4)
#define TCCR4C			_SFR_MEM8(0xa2)
#define TCCR4B			_SFR_MEM8(0xa1)
#define TCCR4A			_SFR_MEM8(0xa0)
#define OCR3C			_SFR_MEM16(0x9c)
#define OCR3B			_SFR_MEM16(0x9a)
#define OCR3A			_SFR_MEM16(0x98)
#define ICR3			_SFR_MEM16(0x96)
#define TCNT3			_SFR_MEM16(0x94)
#define TCCR3C			_SFR_MEM8(0x92)
#define TCCR3B			_SFR_MEM8(0x91)
#define TCCR3A			_SFR_MEM8(0x90)
#define OCR1C			_SFR_MEM16(0x8c)
#define OCR1B			_SFR_MEM16(0x8a)
#define OCR1A			_SFR_MEM16(0x88)
#define ICR1			_SFR_MEM16(0x86)
#define TCNT1			_SFR_MEM16(0x84)
#define TCCR1C			_SFR_MEM8(0x82)
#define TCCR1B			_SFR_MEM8(0x81)
#define TCCR1A			_SFR_MEM8(0x80)
#define DIDR1			_SFR_MEM8(0x7f)
#define DIDR0			_SFR_MEM8(0x7e)
#define DIDR2			_SFR_MEM8(0x7d)
#define ADMUX			_SFR_MEM8(0x7c)
#define ADCSRB			_SFR_MEM8(0x7b)
#define ADCSRA			_SFR_MEM8(0x7a)
#define ADCH			_SFR_MEM8(0x79)
#define ADCL			_SFR_MEM8(0x78)
#define XMCRB			_SFR_MEM8(0x75)
#define XMCRA			_SFR_MEM8(0x74)
#define TIMSK5			_SFR_MEM8(0x73)
#define TIMSK4			_SFR_MEM8(0x72)
#define TIMSK3			_SFR_MEM8(0x71)
#define TIMSK2			_SFR_MEM8(0x70)
#define TIMSK1			_SFR_MEM8(0x6f)
#define TIMSK0			_SFR_MEM8(0x6e)
#define PCMSK2			_SFR_MEM8(0x6d)
#define PCMSK1			_SFR_MEM8(0x6c)
#define PCMSK0			_SFR_MEM8(0x6b)
#define EICRB			_SFR_MEM8(0x6a)
#define EICRA			_SFR_MEM8(0x69)
#define PCICR			_SFR_MEM8(0x68)
#define OSCCAL			_SFR_MEM8(0x66)
#define PRR1			_SFR_MEM8(0x65)
#define PRR0			_SFR_MEM8(0x64)
#define CLKPR			_SFR_MEM8(0x61)
#define WDTCSR			_SFR_MEM8(0x60)
#define SREG			_SFR_IO8(0x3f)
#define SP				_SFR_IO16(0x3d)
#define EIND			_SFR_IO8(0x3c)
#define RAMPZ			_SFR_IO8(0x3b)
#define SPMCSR			_SFR_IO8(0x37)
#define MCUCR			_SFR_IO8(0x35)
#define MCUSR			_SFR_IO8(0x34)
#define SMCR			_SFR_IO8(0x33)
#define OCDR			_SFR_IO8(0x31)
#define ACSR			_SFR_IO8(0x30)
#define SPDR			_SFR_IO8(0x2e)
#define SPSR			_SFR_IO8(0x2d)
#define SPCR			_SFR_IO8(0x2c)
#define GPIOR2			_SFR_IO8(0x2b)
#define GPIOR1			_SFR_IO8(0x2a)
#define OCR0B			_SFR_IO8(0x28)
#define OCR0A			_SFR_IO8(0x27)
#define TCNT0			_SFR_IO8(0x26)
#define TCCR0B			_SFR_IO8(0x25)
#define TCCR0A			_SFR_IO8(0x24)
#define GTCCR			_SFR_IO8(0x23)
#define EEARH			_SFR_IO8(0x22)
#define EEARL			_SFR_IO8(0x21)
#define EEDR			_SFR_IO8(0x20)
#define EECR			_SFR_IO8(0x1f)
#define GPIOR0			_SFR_IO8(0x1e)
#define EIMSK			_SFR_IO8(0x1d)
#define EIFR			_SFR_IO8(0x1c)
#define PCIFR			_SFR_IO8(0x1b)
#define TIFR5			_SFR_IO8(0x1a)
#define TIFR4			_SFR_IO8(0x19)
#define TIFR3			_SFR_IO8(0x18)
#define TIFR2			_SFR_IO8(0x17)
#define TIFR1			_SFR_IO8(0x16)
#define TIFR0			_SFR_IO8(0x15)
#define PORTF			_SFR_IO8(0x11)
#define DDRF			_SFR_IO8(0x10)
#define PINF			_SFR_IO8(0x0f)
#define PORTE			_SFR_IO8(0x0e)
#define DDRE			_SFR_IO8(0x0d)
#define PINE			_SFR_IO8(0x0c)
#define PORTD			_SFR_IO8(0x0b)
#define DDRD			_SFR_IO8(0x0a)
#define PIND			_SFR_IO8(0x09)
#define PORTC			_SFR_IO8(0x08)
#define DDRC			_SFR_IO8(0x07)
#define PINC			_SFR_IO8(0x06)
#define PORTB			_SFR_IO8(0x05)
#define DDRB			_SFR_IO8(0x04)
#define PINB			_SFR_IO8(0x03)
#define PORTA			_SFR_IO8(0x02)
#define DDRA			_SFR_IO8(0x01)
#define PINA			_SFR_IO8(0x00)

/* ***** ޯĒ` ********************************************************* */

#define CLKPCE			7

/* ***** ޯ ******************** */
/* WDTCSR - ޯ ϐڼ޽ */
#define WDP0			0		// ޯ ϑOuޯ0
#define WDP1			1		// ޯ ϑOuޯ1
#define WDP2			2		// ޯ ϑOuޯ2
#define WDE				3		// ޯދ
#define WDCE			4		// ޯޕύX
#define WDP3			5		// ޯ ϑOuޯ3
#define WDIE			6		// ޯގԒߊ荞݋
#define WDIF			7		// ޯގԒߊ荞ݗv׸

/* ***** ΰA ************************* */
/* PORTA - ߰Aްoڼ޽ */
#define PORTA0			0		// ߰Aްoڼ޽ ޯ0
#define PORTA1			1		// ߰Aްoڼ޽ ޯ1
#define PORTA2			2		// ߰Aްoڼ޽ ޯ2
#define PORTA3			3		// ߰Aްoڼ޽ ޯ3
#define PORTA4			4		// ߰Aްoڼ޽ ޯ4
#define PORTA5			5		// ߰Aްoڼ޽ ޯ5
#define PORTA6			6		// ߰Aްoڼ޽ ޯ6
#define PORTA7			7		// ߰Aްoڼ޽ ޯ7

/* DDRA - ߰Aްڼ޽ */
#define DDA0			0		// ߰Aްڼ޽ ޯ0
#define DDA1			1		// ߰Aްڼ޽ ޯ1
#define DDA2			2		// ߰Aްڼ޽ ޯ2
#define DDA3			3		// ߰Aްڼ޽ ޯ3
#define DDA4			4		// ߰Aްڼ޽ ޯ4
#define DDA5			5		// ߰Aްڼ޽ ޯ5
#define DDA6			6		// ߰Aްڼ޽ ޯ6
#define DDA7			7		// ߰Aްڼ޽ ޯ7

/* PINA - ߰Aްڼ޽ */
#define PINA0			0		// ߰Aްڼ޽ ޯ0
#define PINA1			1		// ߰Aްڼ޽ ޯ1
#define PINA2			2		// ߰Aްڼ޽ ޯ2
#define PINA3			3		// ߰Aްڼ޽ ޯ3
#define PINA4			4		// ߰Aްڼ޽ ޯ4
#define PINA5			5		// ߰Aްڼ޽ ޯ5
#define PINA6			6		// ߰Aްڼ޽ ޯ6
#define PINA7			7		// ߰Aްڼ޽ ޯ7

/* ***** ߰B ************************ */
/* PORTB - ߰Bްoڼ޽ */
#define PORTB0			0		// ߰Bްoڼ޽ ޯ0
#define PORTB1			1		// ߰Bްoڼ޽ ޯ1
#define PORTB2			2		// ߰Bްoڼ޽ ޯ2
#define PORTB3			3		// ߰Bްoڼ޽ ޯ3
#define PORTB4			4		// ߰Bްoڼ޽ ޯ4
#define PORTB5			5		// ߰Bްoڼ޽ ޯ5
#define PORTB6			6		// ߰Bްoڼ޽ ޯ6
#define PORTB7			7		// ߰Bްoڼ޽ ޯ7

/* DDRB - ߰Bްڼ޽ */
#define DDB0			0		// ߰Bްڼ޽ ޯ0
#define DDB1			1		// ߰Bްڼ޽ ޯ1
#define DDB2			2		// ߰Bްڼ޽ ޯ2
#define DDB3			3		// ߰Bްڼ޽ ޯ3
#define DDB4			4		// ߰Bްڼ޽ ޯ4
#define DDB5			5		// ߰Bްڼ޽ ޯ5
#define DDB6			6		// ߰Bްڼ޽ ޯ6
#define DDB7			7		// ߰Bްڼ޽ ޯ7

/* PINB - ߰Bްڼ޽ */
#define PINB0			0		// ߰Bްڼ޽ ޯ0
#define PINB1			1		// ߰Bްڼ޽ ޯ1
#define PINB2			2		// ߰Bްڼ޽ ޯ2
#define PINB3			3		// ߰Bްڼ޽ ޯ3
#define PINB4			4		// ߰Bްڼ޽ ޯ4
#define PINB5			5		// ߰Bްڼ޽ ޯ5
#define PINB6			6		// ߰Bްڼ޽ ޯ6
#define PINB7			7		// ߰Bްڼ޽ ޯ7

/* ***** ߰C ************************ */
/* PORTC - ߰Cްoڼ޽ */
#define PORTC0			0		// ߰Cްoڼ޽ ޯ0
#define PORTC1			1		// ߰Cްoڼ޽ ޯ1
#define PORTC2			2		// ߰Cްoڼ޽ ޯ2
#define PORTC3			3		// ߰Cްoڼ޽ ޯ3
#define PORTC4			4		// ߰Cްoڼ޽ ޯ4
#define PORTC5			5		// ߰Cްoڼ޽ ޯ5
#define PORTC6			6		// ߰Cްoڼ޽ ޯ6
#define PORTC7			7		// ߰Cްoڼ޽ ޯ7

/* DDRC - ߰Cްڼ޽ */
#define DDC0			0		// ߰Cްڼ޽ ޯ0
#define DDC1			1		// ߰Cްڼ޽ ޯ1
#define DDC2			2		// ߰Cްڼ޽ ޯ2
#define DDC3			3		// ߰Cްڼ޽ ޯ3
#define DDC4			4		// ߰Cްڼ޽ ޯ4
#define DDC5			5		// ߰Cްڼ޽ ޯ5
#define DDC6			6		// ߰Cްڼ޽ ޯ6
#define DDC7			7		// ߰Cްڼ޽ ޯ7

/* PINC - ߰Cްڼ޽ */
#define PINC0			0		// ߰Cްڼ޽ ޯ0
#define PINC1			1		// ߰Cްڼ޽ ޯ1
#define PINC2			2		// ߰Cްڼ޽ ޯ2
#define PINC3			3		// ߰Cްڼ޽ ޯ3
#define PINC4			4		// ߰Cްڼ޽ ޯ4
#define PINC5			5		// ߰Cްڼ޽ ޯ5
#define PINC6			6		// ߰Cްڼ޽ ޯ6
#define PINC7			7		// ߰Cްڼ޽ ޯ7

/* ***** ߰D ************************ */
/* PORTD - ߰Dްoڼ޽ */
#define PORTD0			0		// ߰Dްoڼ޽ ޯ0
#define PORTD1			1		// ߰Dްoڼ޽ ޯ1
#define PORTD2			2		// ߰Dްoڼ޽ ޯ2
#define PORTD3			3		// ߰Dްoڼ޽ ޯ3
#define PORTD4			4		// ߰Dްoڼ޽ ޯ4
#define PORTD5			5		// ߰Dްoڼ޽ ޯ5
#define PORTD6			6		// ߰Dްoڼ޽ ޯ6
#define PORTD7			7		// ߰Dްoڼ޽ ޯ7

/* DDRD - ߰Dްڼ޽ */
#define DDD0			0		// ߰Dްڼ޽ ޯ0
#define DDD1			1		// ߰Dްڼ޽ ޯ1
#define DDD2			2		// ߰Dްڼ޽ ޯ2
#define DDD3			3		// ߰Dްڼ޽ ޯ3
#define DDD4			4		// ߰Dްڼ޽ ޯ4
#define DDD5			5		// ߰Dްڼ޽ ޯ5
#define DDD6			6		// ߰Dްڼ޽ ޯ6
#define DDD7			7		// ߰Dްڼ޽ ޯ7

/* PIND - ߰Dްڼ޽ */
#define PIND0			0		// ߰Dްڼ޽ ޯ0
#define PIND1			1		// ߰Dްڼ޽ ޯ1
#define PIND2			2		// ߰Dްڼ޽ ޯ2
#define PIND3			3		// ߰Dްڼ޽ ޯ3
#define PIND4			4		// ߰Dްڼ޽ ޯ4
#define PIND5			5		// ߰Dްڼ޽ ޯ5
#define PIND6			6		// ߰Dްڼ޽ ޯ6
#define PIND7			7		// ߰Dްڼ޽ ޯ7

/* ***** ߰E ************************ */
/* PORTE - ߰Eްoڼ޽ */
#define PORTE0			0		// ߰Eްoڼ޽ ޯ0
#define PORTE1			1		// ߰Eްoڼ޽ ޯ1
#define PORTE2			2		// ߰Eްoڼ޽ ޯ2
#define PORTE3			3		// ߰Eްoڼ޽ ޯ3
#define PORTE4			4		// ߰Eްoڼ޽ ޯ4
#define PORTE5			5		// ߰Eްoڼ޽ ޯ5
#define PORTE6			6		// ߰Eްoڼ޽ ޯ6
#define PORTE7			7		// ߰Eްoڼ޽ ޯ7

/* DDRE - ߰Eްڼ޽ */
#define DDE0			0		// ߰Eްڼ޽ ޯ0
#define DDE1			1		// ߰Eްڼ޽ ޯ1
#define DDE2			2		// ߰Eްڼ޽ ޯ2
#define DDE3			3		// ߰Eްڼ޽ ޯ3
#define DDE4			4		// ߰Eްڼ޽ ޯ4
#define DDE5			5		// ߰Eްڼ޽ ޯ5
#define DDE6			6		// ߰Eްڼ޽ ޯ6
#define DDE7			7		// ߰Eްڼ޽ ޯ7

/* PINE - ߰Eްڼ޽ */
#define PINE0			0		// ߰Eްڼ޽ ޯ0
#define PINE1			1		// ߰Eްڼ޽ ޯ1
#define PINE2			2		// ߰Eްڼ޽ ޯ2
#define PINE3			3		// ߰Eްڼ޽ ޯ3
#define PINE4			4		// ߰Eްڼ޽ ޯ4
#define PINE5			5		// ߰Eްڼ޽ ޯ5
#define PINE6			6		// ߰Eްڼ޽ ޯ6
#define PINE7			7		// ߰Eްڼ޽ ޯ7

/* ***** ߰F ************************ */
/* PORTF - ߰Eްoڼ޽ */
#define PORTF0			0		// ߰Fްoڼ޽ ޯ0
#define PORTF1			1		// ߰Fްoڼ޽ ޯ1
#define PORTF2			2		// ߰Fްoڼ޽ ޯ2
#define PORTF3			3		// ߰Fްoڼ޽ ޯ3
#define PORTF4			4		// ߰Fްoڼ޽ ޯ4
#define PORTF5			5		// ߰Fްoڼ޽ ޯ5
#define PORTF6			6		// ߰Fްoڼ޽ ޯ6
#define PORTF7			7		// ߰Fްoڼ޽ ޯ7

/* DDRF - ߰Fްڼ޽ */
#define DDF0			0		// ߰Fްڼ޽ ޯ0
#define DDF1			1		// ߰Fްڼ޽ ޯ1
#define DDF2			2		// ߰Fްڼ޽ ޯ2
#define DDF3			3		// ߰Fްڼ޽ ޯ3
#define DDF4			4		// ߰Fްڼ޽ ޯ4
#define DDF5			5		// ߰Fްڼ޽ ޯ5
#define DDF6			6		// ߰Fްڼ޽ ޯ6
#define DDF7			7		// ߰Fްڼ޽ ޯ7

/* PINF - ߰Fްڼ޽ */
#define PINF0			0		// ߰Fްڼ޽ ޯ0
#define PINF1			1		// ߰Fްڼ޽ ޯ1
#define PINF2			2		// ߰Fްڼ޽ ޯ2
#define PINF3			3		// ߰Fްڼ޽ ޯ3
#define PINF4			4		// ߰Fްڼ޽ ޯ4
#define PINF5			5		// ߰Fްڼ޽ ޯ5
#define PINF6			6		// ߰Fްڼ޽ ޯ6
#define PINF7			7		// ߰Fްڼ޽ ޯ7

/* ***** CPU ************************** */
/* SREG - ð ڼ޽ */
#define SREG_C			0		// ذ ׸
#define SREG_Z			1		// 0׸
#define SREG_N			2		// ׸
#define SREG_V			3		// 2̕␔׸
#define SREG_S			4
#define SREG_H			5		// ذ ׸
#define SREG_T			6		// ޯĕʋL
#define SREG_I			7		// S̊荞݋

/* MCUCR - MCUڼ޽ */
#define IVCE			0		// 荞޸ύX
#define IVSEL			1		// 荞޸I
#define PUD				4		// Sٱߋ֎~
#define JTD				7		// JTAG̪֎~

/* MCUSR - MCUڼ޽ */
#define PORF			0		// dONؾ ׸
#define EXTRF			1		// Oؾ ׸
#define BORF			2		// do(BOD)ؾ ׸
#define WDRF			3		// ޯ ؾ ׸
#define JTRF			4		// JTAGؾ ׸

/* XMCRA - Oؐڼ޽A */
#define SRW00			0		// ߰ޑ҂ԑIޯ0
#define SRW01			1		// ߰ޑ҂ԑIޯ1
#define SRW10			2		// ߰ޑ҂ԑIޯ0
#define SRW11			3		// ߰ޑ҂ԑIޯ1
#define SRL0			4		// ҂߰ތxޯ0
#define SRL1			5		// ҂߰ތxޯ1
#define SRL2			6		// ҂߰ތxޯ2
#define SRE				7		// O(SRAM)

/* XMCRB - Oؐڼ޽B */
#define XMM0			0		// O؏ʎՕޯ0
#define XMM1			1		// O؏ʎՕޯ1
#define XMM2			2		// O؏ʎՕޯ2
#define XMBK			7		// O ޽ێ

/* OSCCAL - UZڼ޽ */
#define CAL0			0		// UZlޯ0
#define CAL1			1		// UZlޯ1
#define CAL2			2		// UZlޯ2
#define CAL3			3		// UZlޯ3
#define CAL4			4		// UZlޯ4
#define CAL5			5		// UZlޯ5
#define CAL6			6		// UZlޯ6
#define CAL7			7		// UZlޯ7

/* CLKPR -  ۯOuڼ޽ */
#define CLKPS0			0		// 
#define CLKPS1			1		// 
#define CLKPS2			2		// 
#define CLKPS3			3		// 
#define CPKPCE			7		// 

/* SMCR - x~`Ԑڼ޽ */
#define SE				0		// x~
#define SM0				1		// x~`ԑIޯ0
#define SM1				2		// x~`ԑIޯ1
#define SM2				3		// x~`ԑIޯ2

/* RAMPZ - RAM߰ZIڼ޽ */
#define RAMPZ0			0		// RAM߰ZIڼ޽ ޯ0

/* EIND - gԐڼ޽ */
#define EIND0			0		// ޯ0

/* GPIOR2 - ėpI/Oڼ޽2 */
#define GPIOR20			0		// ėpI/Oڼ޽2ޯ0
#define GPIOR21			1		// ėpI/Oڼ޽2ޯ1
#define GPIOR22			2		// ėpI/Oڼ޽2ޯ2
#define GPIOR23			3		// ėpI/Oڼ޽2ޯ3
#define GPIOR24			4		// ėpI/Oڼ޽2ޯ4
#define GPIOR25			5		// ėpI/Oڼ޽2ޯ5
#define GPIOR26			6		// ėpI/Oڼ޽2ޯ6
#define GPIOR27			7		// ėpI/Oڼ޽2ޯ7

/* GPIOR1 - ėpI/Oڼ޽1 */
#define GPIOR10			0		// ėpI/Oڼ޽1ޯ0
#define GPIOR11			1		// ėpI/Oڼ޽1ޯ1
#define GPIOR12			2		// ėpI/Oڼ޽1ޯ2
#define GPIOR13			3		// ėpI/Oڼ޽1ޯ3
#define GPIOR14			4		// ėpI/Oڼ޽1ޯ4
#define GPIOR15			5		// ėpI/Oڼ޽1ޯ5
#define GPIOR16			6		// ėpI/Oڼ޽1ޯ6
#define GPIOR17			7		// ėpI/Oڼ޽1ޯ7

/* GPIOR0 - ėpI/Oڼ޽0 */
#define GPIOR00			0		// ėpI/Oڼ޽0ޯ0
#define GPIOR01			1		// ėpI/Oڼ޽0ޯ1
#define GPIOR02			2		// ėpI/Oڼ޽0ޯ2
#define GPIOR03			3		// ėpI/Oڼ޽0ޯ3
#define GPIOR04			4		// ėpI/Oڼ޽0ޯ4
#define GPIOR05			5		// ėpI/Oڼ޽0ޯ5
#define GPIOR06			6		// ėpI/Oڼ޽0ޯ6
#define GPIOR07			7		// ėpI/Oڼ޽0ޯ7

/* PRR1 - d͍팸ڼ޽1 */
#define PRUSART1		0		// USART1d͍팸
#define PRUSART2		1		// USART2d͍팸
#define PRUSART3		2		// USART3d͍팸
#define PRTIM3			3		// /3d͍팸
#define PRTIM4			4		// /4d͍팸
#define PRTIM5			5		// /5d͍팸

/* PRR0 - d͍팸ڼ޽0 */
#define PRADC			0		// ADCd͍팸
#define PRUSART0		1		// USART0d͍팸
#define PRSPI			2		// SPId͍팸
#define PRTIM1			3		// /1d͍팸
#define PRTIM0			5		// /0d͍팸
#define PRTIM2			6		// /2d͍팸
#define PRTWI			7		// TWId͍팸

/* ***** TWI ************************** */
/* TWAMR - TWI(]u)ڽՕڼ޽ */
#define TWAM0			1		// 
#define TWAMR0			TWAM0	// ݊p
#define TWAM1			2		// 
#define TWAMR1			TWAM1	// ݊p
#define TWAM2			3		// 
#define TWAMR2			TWAM2	// ݊p
#define TWAM3			4		// 
#define TWAMR3			TWAM3	// ݊p
#define TWAM4			5		// 
#define TWAMR4			TWAM4	// ݊p
#define TWAM5			6		// 
#define TWAMR5			TWAM5	// ݊p
#define TWAM6			7		// 
#define TWAMR6			TWAM6	// ݊p

/* TWBR - TWIޯđxڼ޽ */
#define TWBR0			0		// 
#define TWBR1			1		// 
#define TWBR2			2		// 
#define TWBR3			3		// 
#define TWBR4			4		// 
#define TWBR5			5		// 
#define TWBR6			6		// 
#define TWBR7			7		// 

/* TWCR - TWIڼ޽ */
#define TWIE			0		// TWI荞݋
#define TWEN			2		// TWI
#define TWWC			3		// TWIݏՓ׸
#define TWSTO			4		// TWI~ޯ
#define TWSTA			5		// TWIJnޯ
#define TWEA			6		// TWIޯ
#define TWINT			7		// TWI荞ݗv׸

/* TWSR - TWIڼ޽ */
#define TWPS0			0       // TWIOuޯ0
#define TWPS1			1       // TWIOuޯ1
#define TWS3			3       // TWIԕޯ3
#define TWS4			4       // TWIԕޯ4
#define TWS5			5       // TWIԕޯ5
#define TWS6			6       // TWIԕޯ6
#define TWS7			7       // TWIԕޯ7

/* TWDR - TWIް ڼ޽ */
#define TWD0			0       // TWIް ޯ0
#define TWD1			1       // TWIް ޯ1
#define TWD2			2       // TWIް ޯ2
#define TWD3			3       // TWIް ޯ3
#define TWD4			4       // TWIް ޯ4
#define TWD5			5       // TWIް ޯ5
#define TWD6			6       // TWIް ޯ6
#define TWD7			7       // TWIް ޯ7

/* TWAR - TWI(]u)ڽ ڼ޽ */
#define TWGCE			0		// TWIČĂяo
#define TWA0			1		// TWI(]u)ڽ ޯ0
#define TWA1			2		// TWI(]u)ڽ ޯ1
#define TWA2			3		// TWI(]u)ڽ ޯ2
#define TWA3			4		// TWI(]u)ڽ ޯ3
#define TWA4			5		// TWI(]u)ڽ ޯ4
#define TWA5			6		// TWI(]u)ڽ ޯ5
#define TWA6			7		// TWI(]u)ڽ ޯ6

/* ***** SPI ************************** */
/* SPDR - SPIް ڼ޽ */
#define SPDR0			0		// SPIް ޯ0
#define SPDR1			1		// SPIް ޯ1
#define SPDR2			2		// SPIް ޯ2
#define SPDR3			3		// SPIް ޯ3
#define SPDR4			4		// SPIް ޯ4
#define SPDR5			5		// SPIް ޯ5
#define SPDR6			6		// SPIް ޯ6
#define SPDR7			7		// SPIް ޯ7

/* SPSR - SPIڼ޽ */
#define SPI2X			0		// SPI 2{
#define WCOL			6		// ݏՓ׸
#define SPIF			7		// SPI荞ݗv׸

/* SPCR - SPIڼ޽ */
#define SPR0			0		// SPIۯxIޯ0
#define SPR1			1		// SPIۯxIޯ1
#define CPHA			2		// ۯʑ
#define CPOL			3		// ۯɐ
#define MSTR			4		// 呕u/]uI
#define DORD			5		// ް
#define SPE				6		// SPI
#define SPIE			7		// SPI荞݋

/* ***** USART1 *********************** */
/* UDR1 - USARTް ڼ޽ */
#define UDR1_0			0		// USARTް ޯ0
#define UDR1_1			1		// USARTް ޯ1
#define UDR1_2			2		// USARTް ޯ2
#define UDR1_3			3		// USARTް ޯ3
#define UDR1_4			4		// USARTް ޯ4
#define UDR1_5			5		// USARTް ޯ5
#define UDR1_6			6		// USARTް ޯ6
#define UDR1_7			7		// USARTް ޯ7

/* UCSR1A - USART/ڼ޽A */
#define MPCM1			0		// ۾ʐM`
#define U2X1			1		// USART 2{ʐM
#define UPE1			2		// è
#define DOR1			3		// ް ް
#define FE1				4		// ڰݸތ
#define UDRE1			5		// USARTް ڼ޽
#define TXC1			6		// USARTM
#define RXC1			7		// USARTM

/* UCSR1B - USART/ڼ޽B */
#define TXB81			0		// Mް ޯ8
#define RXB81			1		// Mް ޯ8
#define UCSZ12			2		// ް ޯĐIޯ2
#define TXEN1			3		// M
#define RXEN1			4		// M
#define UDRIE1			5		// USARTް ڼ޽󊄂荞݋
#define TXCIE1			6		// M荞݋
#define RXCIE1			7		// M荞݋

/* UCSR1C - USART/ڼ޽C */
#define UCPOL1			0		// ۯɐ
#define UCSZ10			1		// ް ޯĐIޯ0
#define UCSZ11			2		// ް ޯĐIޯ1
#define USBS1			3		// ~ޯđI
#define UPM10			4		// è`ޯ0
#define UPM11			5		// è`ޯ1
#define UMSEL10			6		// USART`ԑIޯ0
#define UMSEL11			7		// USARTT`ԑIޯ1

/* ***** USB_u ********************* */
/* UDCON -  */
#define DETACH			0		// 
#define RMWKUP			1		// 
#define LSM				2		// 

/* UDINT -  */
#define SUSPI			0		// 
#define MSOFI			1		// 
#define SOFI			2		// 
#define EORSTI			3		// 
#define WAKEUPI			4		// 
#define EORSMI			5		// 
#define UPRSMI			6		// 

/* UDIEN -  */
#define SUSPE			0		// 
#define MSOFE			1		// 
#define SOFE			2		// 
#define EORSTE			3		// 
#define WAKEUPE			4		// 
#define EORSME			5		// 
#define UPRSME			6		// 

/* UDADDR -  */
#define UDADDR0			0		// 
#define UDADDR1			1		// 
#define UDADDR2			2		// 
#define UDADDR3			3		// 
#define UDADDR4			4		// 
#define UDADDR5			5		// 
#define UDADDR6			6		// 
#define ADDEN			7		// 

/* UDFNUML -  */
#define UDFNUML_0		0		// 
#define UDFNUML_1		1		// 
#define UDFNUML_2		2		// 
#define UDFNUML_3		3		// 
#define UDFNUML_4		4		// 
#define UDFNUML_5		5		// 
#define UDFNUML_6		6		// 
#define UDFNUML_7		7		// 

/* UDFNUMH -  */
#define UDFNUMH_0		0		// 
#define UDFNUMH_1		1		// 
#define UDFNUMH_2		2		// 

/* UDMFN -  */
#define FNCERR			4		// 

/* UEINTX -  */
#define TXINI			0		// 
#define STALLEDI		1		// 
#define RXOUTI			2		// 
#define RXSTPI			3		// 
#define NAKOUTI			4		// 
#define RWAL			5		// 
#define NAKINI			6		// 
#define FIFOCON			7		// 

/* UENUM -  */
#define UENUM_0			0		// 
#define UENUM_1			1		// 
#define UENUM_2			2		// 

/* UERST -  */
#define EPRST0			0		// 
#define EPRST1			1		// 
#define EPRST2			2		// 
#define EPRST3			3		// 
#define EPRST4			4		// 
#define EPRST5			5		// 
#define EPRST6			6		// 

/* UECONX -  */
#define EPEN			0		// 
#define RSTDT			3		// 
#define STALLRQC		4		// 
#define STALLRQ			5		// 

/* UECFG0X -  */
#define EPDIR			0		// 
#define NYETDIS			1		// 
#define AUTOSW			2		// 
#define ISOSW			3		// 
#define EPTYPE0			6		// 
#define EPTYPE1			7		// 

/* UECFG1X -  */
#define ALLOC			1		// 
#define EPBK0			2		// 
#define EPBK1			3		// 
#define EPSIZE0			4		// 
#define EPSIZE1			5		// 
#define EPSIZE2			6		// 

/* UESTA0X -  */
#define NBUSYBK0		0		// 
#define NBUSYBK1		1		// 
#define DTSEQ0			2		// 
#define DTSEQ1			3		// 
#define ZLPSEEN			4		// 
#define UNDERFI			5		// 
#define OVERFI			6		// 
#define CFGOK			7		// 

/* UESTA1X -  */
#define CURRBK0			0		// 
#define CURRBK1			1		// 
#define CTRLDIR			2		// 

/* UEIENX -  */
#define TXINE			0		// 
#define STALLEDE		1		// 
#define RXOUTE			2		// 
#define RXSTPE			3		// 
#define NAKOUTE			4		// 
#define NAKINE			6		// 
#define FLERRE			7		// 

/* UEDATX -  */
#define UEDATX_0		0		// 
#define UEDATX_1		1		// 
#define UEDATX_2		2		// 
#define UEDATX_3		3		// 
#define UEDATX_4		4		// 
#define UEDATX_5		5		// 
#define UEDATX_6		6		// 
#define UEDATX_7		7		// 

/* UEBCLX -  */
#define UEBCLX_0		0		// 
#define UEBCLX_1		1		// 
#define UEBCLX_2		2		// 
#define UEBCLX_3		3		// 
#define UEBCLX_4		4		// 
#define UEBCLX_5		5		// 
#define UEBCLX_6		6		// 
#define UEBCLX_7		7		// 

/* UEBCHX -  */
#define UEBCHX_0		0		// 
#define UEBCHX_1		1		// 
#define UEBCHX_2		2		// 

/* UEINT -  */
#define UEINT_0			0		// 
#define UEINT_1			1		// 
#define UEINT_2			2		// 
#define UEINT_3			3		// 
#define UEINT_4			4		// 
#define UEINT_5			5		// 
#define UEINT_6			6		// 

/* ***** USB_S ********************* */
/* UHWCON - USBʰ޳`Ԑݒڼ޽ */
#define UVREGE			0		// 
#define UVCONE			4		// 
#define UIDE			6		// 
#define UIMOD			7		// 

/* USBCON - USBSʐڼ޽ */
#define VBUSTE			0		// 
#define IDTE			1		// 
#define OTGPADE			4		// 
#define FRZCLK			5		// 
#define HOST			6		// 
#define USBE			7		// 

/* USBSTA -  */
#define VBUS			0		// 
#define ID				1		// 
#define SPEED1			3		// 

/* USBINT -  */
#define VBUSTI			0		// 
#define IDTI			1		// 

/* OTGTCON -  */
#define OTGTCON_0		0		// 
#define OTGTCON_1		1		// 
#define OTGTCON_2		2		// 
#define OTGTCON_3		3		// 
#define OTGTCON_4		4		// 
#define OTGTCON_5		5		// 
#define OTGTCON_6		6		// 
#define OTGTCON_7		7		// 

/* OTGCON -  */
#define VBUSRQC			0		// 
#define VBUSREQ			1		// 
#define VBUSHWC			2		// 
#define SRPSEL			3		// 
#define SRPREQ			4		// 
#define HNPREQ			5		// 

/* OTGIEN -  */
#define SRPE			0		// 
#define VBERRE			1		// 
#define BCERRE			2		// 
#define ROLEEXE			3		// 
#define HNPERRE			4		// 
#define STOE			5		// 

/* OTGINT -  */
#define SRPI			0		// 
#define VBERRI			1		// 
#define BCERRI			2		// 
#define ROLEEXI			3		// 
#define HNPERRI			4		// 
#define STOI			5		// 

/* ***** USB_ν ********************** */
/* UHCON -  */
#define SOFEN			0		// 
#define RESET			1		// 
#define RESUME			2		// 

/* UHINT -  */
#define DCONNI			0		// 
#define DDISCI			1		// 
#define RSTI			2		// 
#define RSMEDI			3		// 
#define RXRSMI			4		// 
#define HSOFI			5		// 
#define HWUPI			6		// 

/* UHIEN -  */
#define HWUPE			6
#define HSOFE			5
#define RXRSME			4
#define RSMEDE			3
#define RSTE			2
#define DDISCE			1
#define DCONNE			0

/* UHADDR -  */
#define UHADDR_0		0		// 
#define UHADDR_1		1		// 
#define UHADDR_2		2		// 
#define UHADDR_3		3		// 
#define UHADDR_4		4		// 
#define UHADDR_5		5		// 
#define UHADDR_6		6		// 

/* UHFNUMH -  */
#define UHFNUMH_0		0		// 
#define UHFNUMH_1		1		// 
#define UHFNUMH_2		2		// 

/* UHFNUML -  */
#define UHFNUML_0		0		// 
#define UHFNUML_1		1		// 
#define UHFNUML_2		2		// 
#define UHFNUML_3		3		// 
#define UHFNUML_4		4		// 
#define UHFNUML_5		5		// 
#define UHFNUML_6		6		// 
#define UHFNUML_7		7		// 

/* UHFLEN -  */
#define UHFLEN_0		0		// 
#define UHFLEN_1		1		// 
#define UHFLEN_2		2		// 
#define UHFLEN_3		3		// 
#define UHFLEN_4		4		// 
#define UHFLEN_5		5		// 
#define UHFLEN_6		6		// 
#define UHFLEN_7		7		// 

/* UPINRQX -  */
#define INRQ0			0		// 
#define INRQ1			1		// 
#define INRQ2			2		// 
#define INRQ3			3		// 
#define INRQ4			4		// 
#define INRQ5			5		// 
#define INRQ6			6		// 
#define INRQ7			7		// 

/* UPINTX -  */
#define RXINI			0		// 
#define RXSTALLI		1		// 
#define TXOUTI			2		// 
#define TXSTPI			3		// 
#define PERRI			4		// 
//#define RWAL			5		// 
#define NAKEDI			6		// 
//#define FIFOCON		7		// 

/* UPNUM -  */
#define PNUM0			0		// 
#define PNUM1			1		// 
#define PNUM2			2		// 

/* UPRST -  */
#define PRST0			0		// 
#define PRST1			1		// 
#define PRST2			2		// 
#define PRST3			3		// 
#define PRST4			4		// 
#define PRST5			5		// 
#define PRST6			6		// 

/* UPCONX -  */
#define PEN				0		// 
//#define RSTDT			3		// 
#define INMODE			5		// 
#define PFREEZE			6		// 

/* UPCFG0X -  */
#define PEPNUM0			0		// 
#define PEPNUM1			1		// 
#define PEPNUM2			2		// 
#define PEPNUM3			3		// 
#define PTOKEN0			4		// 
#define PTOKEN1			5		// 
#define PTYPE0			6		// 
#define PTYPE1			7		// 

/* UPCFG1X -  */
//#define ALLOC			1		// 
#define PBK0			2		// 
#define PBK1			3		// 
#define PSIZE0			4		// 
#define PSIZE1			5		// 
#define PSIZE2			6		// 

/* UPSTAX -  */
#define NBUSYK0			0		// 
#define NBUSYK1			1		// 
//#define DTSEQ0		2		// 
//#define DTSEQ1		3		// 
//#define UNDERFI		5		// 
//#define OVERFI		6		// 
//#define CFGOK			7		// 

/* UPCFG2X -  */
#define UPCFG2X_0		0		// 
#define UPCFG2X_1		1		// 
#define UPCFG2X_2		2		// 
#define UPCFG2X_3		3		// 
#define UPCFG2X_4		4		// 
#define UPCFG2X_5		5		// 
#define UPCFG2X_6		6		// 
#define UPCFG2X_7		7		// 

/* UPIENX -  */
#define RXINE			0		// 
#define RXSTALLE		1		// 
#define TXOUTE			2		// 
#define TXSTPE			3		// 
#define PERRE			4		// 
#define NAKEDE			6		// 
//#define FLERRE		7		// 

/* UPDATX -  */
#define PDAT0			0		// 
#define PDAT1			1		// 
#define PDAT2			2		// 
#define PDAT3			3		// 
#define PDAT4			4		// 
#define PDAT5			5		// 
#define PDAT6			6		// 
#define PDAT7			7		// 

/* UPBCLX -  */
#define PBYCT0			0		// 
#define PBYCT1			1		// 
#define PBYCT2			2		// 
#define PBYCT3			3		// 
#define PBYCT4			4		// 
#define PBYCT5			5		// 
#define PBYCT6			6		// 
#define PBYCT7			7		// 

/* UPBCHX -  */
#define PBYCT8			0		// 
#define PBYCT9			1		// 
#define PBYCT10			2		// 

/* UPINT -  */
#define PINT0			0		// 
#define PINT1			1		// 
#define PINT2			2		// 
#define PINT3			3		// 
#define PINT4			4		// 
#define PINT5			5		// 
#define PINT6			6		// 

/* UPERRX -  */
#define DATATGL			0		// 
#define DATAPID			1		// 
#define PID				2		// 
#define TIMEOUT			3		// 
#define CRC16			4		// 
#define COUNTER0		5		// 
#define COUNTER1		6		// 

/* ***** BOOT_LOAD ******************** */
/* SPMCSR - SPMߐڼ޽ */
#define SPMEN			0		// SPMߏ
#define PGERS			1		// ߰ޏ
#define PGWRT			2		// ߰ޏ
#define BLBSET			3		// ްĎ{ޯĐݒ
#define RWWSRE			4		// RWẄǂݍ݋
#define SIGRD			5		// [ǂݍ
#define RWWSB			6		// RWẄ摽Z
#define SPMIE			7		// SPM荞݋

/* ***** EEPROM *********************** */
/* EEARH - EEPROMڽ ڼ޽޲ */
#define EEAR8			0		// EEPROMڽ ޯ8
#define EEAR9			1		// EEPROMڽ ޯ9
#define EEAR10			2		// EEPROMڽ ޯ10
#define EEAR11			3		// EEPROMڽ ޯ11

/* EEARL - EEPROMڽ ڼ޽޲ */
#define EEAR0			0		// EEPROMڽ ޯ0
#define EEAR1			1		// EEPROMڽ ޯ1
#define EEAR2			2		// EEPROMڽ ޯ2
#define EEAR3			3		// EEPROMڽ ޯ3
#define EEAR4			4		// EEPROMڽ ޯ4
#define EEAR5			5		// EEPROMڽ ޯ5
#define EEAR6			6		// EEPROMڽ ޯ6
#define EEAR7			7		// EEPROMڽ ޯ7

/* EEDR - EEPROMް ڼ޽ */
#define EEDR0			0		// EEPROMް ޯ0
#define EEDR1			1		// EEPROMް ޯ1
#define EEDR2			2		// EEPROMް ޯ2
#define EEDR3			3		// EEPROMް ޯ3
#define EEDR4			4		// EEPROMް ޯ4
#define EEDR5			5		// EEPROMް ޯ5
#define EEDR6			6		// EEPROMް ޯ6
#define EEDR7			7		// EEPROMް ޯ7

/* EECR - EEPROMڼ޽ */
#define EERE			0		// EEPROMǂݍ݋
#define EEPE			1		// EEPROM݋
#define EEMPE			2		// EEPROM发݋
#define EERIE			3		// EEPROM荞݋
#define EEPM0			4		// EEPROM۸ݸޓޯ0
#define EEPM1			5		// EEPROM۸ݸޓޯ1

/* ***** TIMER_COUNTER_0 ************** */
/* TIMSK0 - /0荞݋ڼ޽ */
#define TOIE0			0		// /0ꊄ荞݋
#define OCIE0A			1		// /0rAv荞݋
#define OCIE0B			2		// /0rBv荞݋

/* TIFR0 - /0荞ݗv׸ ڼ޽ */
#define TOV0			0		// /0ꊄ荞ݗv׸
#define OCF0A			1		// /0rAv荞ݗv׸
#define OCF0B			2		// /0rBv荞ݗv׸

/* TCCR0A - /0ڼ޽A */
#define WGM00			0		// g`ޯ0
#define WGM01			1		// g`ޯ1
#define COM0B0			4		// rBvo͎ޯ0
#define COM0B1			5		// rBvo͎ޯ1
#define COM0A0			6		// rAvo͎ޯ0
#define COM0A1			7		// rAvo͎ޯ1

/* TCCR0B - /0ڼ޽B */
#define CS00			0		// ۯIޯ0
#define CS01			1		// ۯIޯ1
#define CS02			2		// ۯIޯ2
#define WGM02			3		// 
#define FOC0B			6		// rBo͋
#define FOC0A			7		// rAo͋

/* TCNT0 - /0 */
#define TCNT0_0			0		// 
#define TCNT0_1			1		// 
#define TCNT0_2			2		// 
#define TCNT0_3			3		// 
#define TCNT0_4			4		// 
#define TCNT0_5			5		// 
#define TCNT0_6			6		// 
#define TCNT0_7			7		// 

/* OCR0A - /0rAڼ޽ */
#define OCROA_0			0		// 
#define OCROA_1			1		// 
#define OCROA_2			2		// 
#define OCROA_3			3		// 
#define OCROA_4			4		// 
#define OCROA_5			5		// 
#define OCROA_6			6		// 
#define OCROA_7			7		// 

/* OCR0B - /0rBڼ޽ */
#define OCR0B_0			0		// 
#define OCR0B_1			1		// 
#define OCR0B_2			2		// 
#define OCR0B_3			3		// 
#define OCR0B_4			4		// 
#define OCR0B_5			5		// 
#define OCR0B_6			6		// 
#define OCR0B_7			7		// 

/* GTCCR - S/ڼ޽ */
#define PSRSYNC			0		// n/Ouؾ
#define PSR10			PSRSYNC	// ݊p
#define TSM				7		// /

/* ***** TIMER_COUNTER_2 ************** */
/* TIMSK2 - /2荞݋ڼ޽ */
#define TOIE2			0		// /2ꊄ荞݋
#define TOIE2A			TOIE2	// ݊p
#define OCIE2A			1		// /2rAv荞݋
#define OCIE2B			2		// /2rBv荞݋

/* TIFR2 - /2荞ݗv׸ ڼ޽ */
#define TOV2			0		// /2ꊄ荞ݗv׸
#define OCF2A			1		// rAv荞ݗv׸
#define OCF2B			2		// rBv荞ݗv׸

/* TCCR2A - /2ڼ޽A */
#define WGM20			0		// g`ޯ0
#define WGM21			1		// g`ޯ1
#define COM2B0			4		// rBvo͎ޯ0
#define COM2B1			5		// rBvo͎ޯ1
#define COM2A0			6		// rAvo͎ޯ0
#define COM2A1			7		// rAvo͎ޯ1

/* TCCR2B - /2ڼ޽B */
#define CS20			0		// ۯIޯ0
#define CS21			1		// ۯIޯ1
#define CS22			2		// ۯIޯ2
#define WGM22			3		// g`ޯ2
#define FOC2B			6		// rBvo͋
#define FOC2A			7		// rAvo͋

/* TCNT2 - /2 */
#define TCNT2_0			0		// /2ޯ0
#define TCNT2_1			1		// /2ޯ1
#define TCNT2_2			2		// /2ޯ2
#define TCNT2_3			3		// /2ޯ3
#define TCNT2_4			4		// /2ޯ4
#define TCNT2_5			5		// /2ޯ5
#define TCNT2_6			6		// /2ޯ6
#define TCNT2_7			7		// /2ޯ7

/* OCR2A - /2rAڼ޽ */
#define OCR2_0			0		// rAޯ0
#define OCR2_1			1		// rAޯ1
#define OCR2_2			2		// rAޯ2
#define OCR2_3			3		// rAޯ3
#define OCR2_4			4		// rAޯ4
#define OCR2_5			5		// rAޯ5
#define OCR2_6			6		// rAޯ6
#define OCR2_7			7		// rAޯ7

/* OCR2B - /2rBڼ޽ */
//#define OCR2_0		0		// rBޯ0
//#define OCR2_1		1		// rBޯ1
//#define OCR2_2		2		// rBޯ2
//#define OCR2_3		3		// rBޯ3
//#define OCR2_4		4		// rBޯ4
//#define OCR2_5		5		// rBޯ5
//#define OCR2_6		6		// rBޯ6
//#define OCR2_7		7		// rBޯ7

/* ASSR - /2񓯊ڼ޽ */
#define TCR2BUB			0		// /2ڼ޽BXV
#define TCR2AUB			1		// /2ڼ޽AXV
#define OCR2BUB			2		// /2rBڼ޽XV
#define OCR2AUB			3		// /2rAڼ޽XV
#define TCN2UB			4		// /2XV
#define AS2				5		// /2񓯊
#define EXCLK			6		// Oۯ͋

/* GTCCR - S/ڼ޽ */
#define PSRASY			1		// 񓯊n/Ouؾ
#define PSR2			PSRASY	// ݊p
//#define TSM			7		// /

/* ***** TIMER_COUNTER_3 ************** */
/* TIMSK3 - /3荞݋ڼ޽ */
#define TOIE3			0		// /3ꊄ荞݋
#define OCIE3A			1		// /3rAv荞݋
#define OCIE3B			2		// /3rBv荞݋
#define OCIE3C			3		// /3rCv荞݋
#define ICIE3			5		// /3ߊl荞݋

/* TIFR3 - /3荞ݗv׸ ڼ޽ */
#define TOV3			0		// /3ꊄ荞ݗv׸
#define OCF3A			1		// /3rAv荞ݗv׸
#define OCF3B			2		// /3rBv荞ݗv׸
#define OCF3C			3		// /3rCv荞ݗv׸
#define ICF3			5		// /3ߊl荞ݗv׸

/* TCCR3A - /3ڼ޽A */
#define WGM30			0		// g`ޯ0
#define WGM31			1		// g`ޯ1
#define COM3C0			2		// rCvo͎ޯ0
#define COM3C1			3		// rCvo͎ޯ1
#define COM3B0			4		// rBvo͎ޯ0
#define COM3B1			5		// rBvo͎ޯ1
#define COM3A0			6		// rAvo͎ޯ0
#define COM3A1			7		// rAvo͎ޯ1

/* TCCR3B - /3ڼ޽B */
#define CS30			0		// ۯIޯ0
#define CS31			1		// ۯIޯ1
#define CS32			2		// ۯIޯ2
#define WGM32			3		// g`ޯ2
#define WGM33			4		// g`ޯ3
#define ICES3			6		// ߊlʹޑI
#define ICNC3			7		// ߊl͎G

/* TCCR3C - /3ڼ޽C */
#define FOC3C			5		// rCo͋
#define FOC3B			6		// rBo͋
#define FOC3A			7		// rAo͋

/* ***** TIMER_COUNTER_1 ************** */
/* TIMSK1 - /1荞݋ڼ޽ */
#define TOIE1			0		// /1ꊄ荞݋
#define OCIE1A			1		// /1rAv荞݋
#define OCIE1B			2		// /1rBv荞݋
#define OCIE1C			3		// /1rCv荞݋
#define ICIE1			5		// /1ߊl荞݋

/* TIFR1 - /1荞ݗv׸ ڼ޽ */
#define TOV1			0		// /1ꊄ荞ݗv׸
#define OCF1A			1		// /1rAv荞ݗv׸
#define OCF1B			2		// /1rBv荞ݗv׸
#define OCF1C			3		// /1rCv荞ݗv׸
#define ICF1			5		// /1ߊl荞ݗv׸

/* TCCR1A - /1ڼ޽A */
#define GM10			0		// g`ޯ0
#define GM11			1		// g`ޯ1
#define OM1C0			2		// rCvo͎ޯ0
#define OM1C1			3		// rCvo͎ޯ1
#define OM1B0			4		// rBvo͎ޯ0
#define OM1B1			5		// rBvo͎ޯ1
#define OM1A0			6		// rAvo͎ޯ0
#define OM1A1			7		// rAvo͎ޯ1

/* TCCR1B - /1ڼ޽B */
#define CS10			0		// ۯIޯ0
#define CS11			1		// ۯIޯ1
#define CS12			2		// ۯIޯ2
#define WGM12			3		// g`ޯ2
#define WGM13			4		// g`ޯ3
#define ICES1			6		// ߊlʹޑI
#define ICNC1			7		// ߊl͎G

/* TCCR1C - /1ڼ޽C */
#define FOC1C			5		// rCo͋
#define FOC1B			6		// rBo͋
#define FOC1A			7		// rAo͋

/* ***** JTAG ************************* */
/* OCDR - ߏޯފ֘Aڼ޽ */
#define OCDR0			0		// ߏޯ ڼ޽ ޯ0
#define OCDR1			1		// ߏޯ ڼ޽ ޯ1
#define OCDR2			2		// ߏޯ ڼ޽ ޯ2
#define OCDR3			3		// ߏޯ ڼ޽ ޯ3
#define OCDR4			4		// ߏޯ ڼ޽ ޯ4
#define OCDR5			5		// ߏޯ ڼ޽ ޯ5
#define OCDR6			6		// ߏޯ ڼ޽ ޯ6
#define OCDR7			7		// ߏޯ ڼ޽ ޯ7
#define IDRD			OCDR7	// ݊p

/* MCUCR - MCUڼ޽ */
//#define JTD			7		// JTAG̪֎~

/* MCUSR - MCUڼ޽ */
//#define JTRF			4		// JTAGؾ ׸

/* ***** EXTERNAL_INTERRUPT *********** */
/* EICRA - O荞ݐڼ޽A */
#define ISC00			0		// O荞0mޯ0
#define ISC01			1		// O荞0mޯ1
#define ISC10			2		// O荞1mޯ0
#define ISC11			3		// O荞1mޯ1
#define ISC20			4		// O荞2mޯ0
#define ISC21			5		// O荞2mޯ1
#define ISC30			6		// O荞3mޯ0
#define ISC31			7		// O荞3mޯ1

/* EICRB - O荞ݐڼ޽B */
#define ISC40			0		// O荞4mޯ0
#define ISC41			1		// O荞4mޯ1
#define ISC50			2		// O荞5mޯ0
#define ISC51			3		// O荞5mޯ1
#define ISC60			4		// O荞6mޯ0
#define ISC61			5		// O荞6mޯ1
#define ISC70			6		// O荞7mޯ0
#define ISC71			7		// O荞7mޯ1

/* EIMSK - O荞݋ڼ޽ */
#define INT0			0		// O荞ݗv0
#define INT1			1		// O荞ݗv1
#define INT2			2		// O荞ݗv2
#define INT3			3		// O荞ݗv3
#define INT4			4		// O荞ݗv4
#define INT5			5		// O荞ݗv5
#define INT6			6		// O荞ݗv6
#define INT7			7		// O荞ݗv7

/* EIFR - O荞ݗv׸ ڼ޽ */
#define INTF0			0		// O荞ݗv0׸
#define INTF1			1		// O荞ݗv1׸
#define INTF2			2		// O荞ݗv2׸
#define INTF3			3		// O荞ݗv3׸
#define INTF4			4		// O荞ݗv4׸
#define INTF5			5		// O荞ݗv5׸
#define INTF6			6		// O荞ݗv6׸
#define INTF7			7		// O荞ݗv7׸

/* PCICR - ݕω荞ݐڼ޽ */
#define PCIE0			0		// ݕω荞0Q
#define PCIE1			1		// ݕω荞1Q
#define PCIE2			2		// ݕω荞2Q

/* PCIFR - ݕω荞ݗv׸ ڼ޽ */
#define PCIF0			0		// ݕω荞0Q荞ݗv׸
#define PCIF1			1		// ݕω荞1Q荞ݗv׸
#define PCIF2			2		// ݕω荞2Q荞ݗv׸

/* PCMSK0 - ݕω荞0Qڼ޽ */
#define PCINT0			0		// ݕω荞0
#define PCINT1			1		// ݕω荞1
#define PCINT2			2		// ݕω荞2
#define PCINT3			3		// ݕω荞3
#define PCINT4			4		// ݕω荞4
#define PCINT5			5		// ݕω荞5
#define PCINT6			6		// ݕω荞6
#define PCINT7			7		// ݕω荞7

/* ***** AD_CONVERTER ***************** */
/* ADMUX - A/DϊdIڼ޽ */
#define MUX0			0		// ۸ قƗ̑Iޯ0
#define MUX1			1		// ۸ قƗ̑Iޯ1
#define MUX2			2		// ۸ قƗ̑Iޯ2
#define MUX3			3		// ۸ قƗ̑Iޯ3
#define MUX4			4		// ۸ قƗ̑Iޯ4
#define ADLAR			5		// 
#define REFS0			6		// dIޯ0
#define REFS1			7		// dIޯ1

/* ADCSRA - A/Dϊ/ڼ޽A */
#define ADPS0			0		// OuIޯ0
#define ADPS1			1		// OuIޯ1
#define ADPS2			2		// OuIޯ2
#define ADIE			3		// ADC荞݋
#define ADIF			4		// ADC荞ݗv׸
#define ADATE			5		// ADCN
#define ADSC			6		// ADCϊJn
#define ADEN			7		// ADC

/* ADCH - ADCް ڼ޽޲ */
#define ADCH0			0		// ADCްޯ0
#define ADCH1			1		// ADCްޯ1
#define ADCH2			2		// ADCްޯ2
#define ADCH3			3		// ADCްޯ3
#define ADCH4			4		// ADCްޯ4
#define ADCH5			5		// ADCްޯ5
#define ADCH6			6		// ADCްޯ6
#define ADCH7			7		// ADCްޯ7

/* ADCL - ADCް ڼ޽޲ */
#define ADCL0			0		// ADCްޯ0
#define ADCL1			1		// ADCްޯ1
#define ADCL2			2		// ADCްޯ2
#define ADCL3			3		// ADCްޯ3
#define ADCL4			4		// ADCްޯ4
#define ADCL5			5		// ADCްޯ5
#define ADCL6			6		// ADCްޯ6
#define ADCL7			7		// ADCްޯ7

/* ADCSRB - A/Dϊ/ڼ޽B */
#define ADTS0			0		// ADCNIޯ0
#define ADTS1			1		// ADCNIޯ1
#define ADTS2			2		// ADCNIޯ2
#define ADHSM			7		// ADC

/* DIDR0 - ޼ٓ͋֎~ڼ޽0 */
#define ADC0D			0		// ADC0޼ٓ͋֎~
#define ADC1D			1		// ADC1޼ٓ͋֎~
#define ADC2D			2		// ADC2޼ٓ͋֎~
#define ADC3D			3		// ADC3޼ٓ͋֎~
#define ADC4D			4		// ADC4޼ٓ͋֎~
#define ADC5D			5		// ADC5޼ٓ͋֎~
#define ADC6D			6		// ADC6޼ٓ͋֎~
#define ADC7D			7		// ADC7޼ٓ͋֎~

/* ***** ANALOG_COMPARATOR ************ */
/* ADCSRB - A/Dϊ/ڼ޽B */
#define ACME			6		// ۸ޔr푽d틖

/* ACSR - ۸ޔr퐧/ڼ޽ */
#define ACIS0			0		// ۸ޔr튄荞ݎʑIޯ0
#define ACIS1			1		// ۸ޔr튄荞ݎʑIޯ1
#define ACIC			2		// ۸ޔr͕ߊl
#define ACIE			3		// ۸ޔr튄荞݋
#define ACI				4		// ۸ޔr튄荞ݗv׸
#define ACO				5		// ۸ޔro
#define ACBG			6		// ۸ޔr޷ެߑI
#define ACD				7		// ۸ޔr֎~

/* DIDR1 - ޼ٓ͋֎~ڼ޽1 */
#define AIN0D			0		// AIN0޼ٓ͋֎~
#define AIN1D			1		// AIN1޼ٓ͋֎~

/* ***** PLL ************************** */
/* PLLCSR - PLL/ڼ޽ */
#define PLOCK			0		// PLLŒ艻׸
#define PLLE			1		// PLL
#define PLLP0			2		// PLLOuޯ0
#define PLLP1			3		// PLLOuޯ1
#define PLLP2			4		// PLLOuޯ2

/* ***** {ޯ ********************************************************* */
#define LB1				0		// {ޯ1
#define LB2				1		// {ޯ2
#define BLB01			2		// ްĎ{ޯ01
#define BLB02			3		// ްĎ{ޯ02
#define BLB11			4		// ްĎ{ޯ10
#define BLB12			5		// ްĎ{ޯ12

/* ***** ˭ ************************************************************ */
/* ˭ ޯ */
#define CKSEL0			0		// ۯIޯ0
#define CKSEL1			1		// ۯIޯ1
#define CKSEL2			2		// ۯIޯ2
#define CKSEL3			3		// ۯIޯ3
#define SUT0			4		// nԑIޯ0
#define SUT1			5		// nԑIޯ1
#define CKOUT			6		// ۯo͋
#define CLKDIV8			7		//  ۯ8

/* ˭ ޯ */
#define BOOTRST			0		// ؾ ޸I
#define BOOTSZ0			1		// ްėeʑIޯ0
#define BOOTSZ1			2		// ްėeʑIޯ1
#define EESAVE			3		// ߏEEPROMی
#define WDTON			4		// ޯ Ϗ펞ON
#define SPIEN			5		// ۸ݸދ
#define JTAGEN			6		// JTAG
#define OCDEN			7		// OCD

/* g˭ ޯ */
#define BODLEVEL0		0		// do(BOD)Iޯ0
#define BODLEVEL1		1		// do(BOD)Iޯ1
#define BODLEVEL2		2		// do(BOD)Iޯ2
#define HWBE			3		// ʰ޳ ްċ

/* ***** CPUڼ޽` ***************************************************** */
#define XH				R27
#define XL				R26
#define YH				R29
#define YL				R28
#define ZH				R31
#define ZL				R30

/* ***** ް ؐ錾 ***************************************************** */
#define FLASHEND		0x1FFFF		// :޲ ڽ
#define IOEND			0x00FF
#define SRAM_START		0x0100
#define SRAM_SIZE		8192
#define RAMEND			0x20FF
#define XRAMEND			0xFFFF
#define E2END			0x0FFF
#define EEPROMEND		0x0FFF
#define EEADRBITS		12

/* ***** ް۰ސ錾 ***************************************************** */
#define NRWW_START_ADDR	0xF000
#define NRWW_STOP_ADDR	0xFFFF
#define RWW_START_ADDR	0x0
#define RWW_STOP_ADDR	0xEFFF
#define PAGESIZE		128
#define FIRSTBOOTSTART	0xFE00
#define SECONDBOOTSTART	0xFC00
#define THIRDBOOTSTART	0xF800
#define FOURTHBOOTSTART	0xF000
#define SMALLBOOTSTART	FIRSTBOOTSTART
#define LARGEBOOTSTART	FOURTHBOOTSTART

/* ***** 荞޸ ***************************************************** */
#define SIG_INTERRUPT0_VECTOR(1)		// O荞ݗv0
#define SIG_INTERRUPT1_VECTOR(2)		// O荞ݗv1
#define SIG_INTERRUPT2_VECTOR(3)		// O荞ݗv2
#define SIG_INTERRUPT3_VECTOR(4)		// O荞ݗv3
#define SIG_INTERRUPT4_VECTOR(5)		// O荞ݗv4
#define SIG_INTERRUPT5_VECTOR(6)		// O荞ݗv5
#define SIG_INTERRUPT6_VECTOR(7)		// O荞ݗv6
#define SIG_INTERRUPT7_VECTOR(8)		// O荞ݗv7
#define SIG_PIN_CHANGE0_VECTOR(9)		// ݕω荞ݗv0
#define SIG_USB_GEN_VECTOR(10)			// USBSʊ荞ݗv
#define SIG_USB_COM_VECTOR(11)			// USB߲/߲ߊ荞ݒʐMv
#define SIG_WDT_VECTOR(12)				// ޯގԒߊ荞
#define SIG_OUTPUT_COMPARE2A_VECTOR(13)	// /2rAv
#define SIG_OUTPUT_COMPARE2B_VECTOR(14)	// /2rBv
#define SIG_OVERFLOW2_VECTOR(15)		// /2
#define SIG_INPUT_CAPTURE1_VECTOR(16)	// /1ߊl
#define SIG_OUTPUT_COMPARE1A_VECTOR(17)	// /1rAv
#define SIG_OUTPUT_COMPARE1B_VECTOR(18)	// /1rBv
#define SIG_OUTPUT_COMPARE1C_VECTOR(19)	// /1rCv
#define SIG_OVERFLOW1_VECTOR(20)		// /1
#define SIG_OUTPUT_COMPARE0A_VECTOR(21)	// /0rAv
#define SIG_OUTPUT_COMPARE0B_VECTOR(22)	// /0rBv
#define SIG_OVERFLOW0_VECTOR(23)		// /0
#define SIG_SPI_VECTOR(24)				// SPI]
#define SIG_USART1_RECV_VECTOR(25)		// USART1M
#define SIG_USART1_DATA_VECTOR(26)		// USART1ް ڼ޽
#define SIG_USART1_TRANS_VECTOR(27)		// USART1M
#define SIG_COMPARATOR_VECTOR(28)		// ۸ޔrv
#define SIG_ADC_VECTOR(29)				// A/Dϊ
#define SIG_EEPROM_READY_VECTOR(30)		// EEPROM
#define SIG_INPUT_CAPTURE3_VECTOR(31)	// /3ߊl
#define SIG_OUTPUT_COMPARE3A_VECTOR(32)	// /3rAv
#define SIG_OUTPUT_COMPARE3B_VECTOR(33)	// /3rBv
#define SIG_OUTPUT_COMPARE3C_VECTOR(34)	// /3rCv
#define SIG_OVERFLOW3_VECTOR(35)		// /3
#define SIG_2WIRE_SERIAL_VECTOR(36)		// 2̪
#define SIG_SPM_READY_VECTOR(37)		// SPMߏ

#define _VECTORS_SIZE	152				// ޲Ăł̑傫

#endif /* _AVR_IOAT90USB1287_H_ */

/* ***** ُ̧I ********************************************************* */
